<template lang="html">
  <div class="upload-about">
    <button class="collapsible-title-button"
      v-on:click="toggleExpanded()"
      v-bind:class="{ expanded: expanded, condensed: !expanded }">
      <span>{{ label.ABOUT }}</span>
    </button>
    <div v-show="expanded" class="content">
      <div v-if="isEditForm">
        <label for="privacy" class="section-title">{{ label.PRIVACY }}</label>
        <div class="filter-item">
          <select id="privacy" class="filter-item-select"
            v-model="privacy">
            <option value="public">{{ label.PUBLIC }}</option>
            <option value="unlisted">{{ label.UNLISTED }}</option>
            <option value="private">{{ label.PRIVATE }}</option>
          </select>
        </div>
      </div>
      <div>
        <label for="title">{{ label.GAME_TITLE }}</label>
        <input id="title"
          type="text"
          :placeholder="label.GAME_TITLE_PLACEHOLDER"
          v-model.trim="title">
        <div v-if="$v.title.$invalid" class="error">
          <span v-if="!$v.title.required">Game title is required.</span>
          <span v-else-if="!$v.title.maxLength">Title must be shorter than 100 characters.</span>
        </div>
      </div>
      <div>
        <label for="description">{{ label.DESCRIPTION }}</label>
        <textarea id="description"
          :placeholder="label.DESCRIPTION_PLACEHOLDER" rows="8" cols="80"
          v-model.trim="description"></textarea>
        <div v-if="$v.description.$invalid" class="error">
          <span v-if="!$v.description.required">Game description is required.</span>
        </div>
      </div>
      <div>
        <label for="price" class="section-title">{{ label.PRICE }}</label>
        <div class="filter-item">
          <select id="price" class="filter-item-select"
            v-model="price.amount">
            <option v-for="amount in validPrices"
              :value="amount">{{ amount > 0 ? totalPrice(amount) : label.FREE_TO_PLAY }}</option>
          </select>
        </div>
        <div v-if="$v.price.$invalid" class="error">
          <span v-if="!$v.price.isValidPrice">Price must be valid</span>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { required, maxLength } from 'vuelidate/lib/validators'
import { isValidPrice } from '~/utils/formValidator'
import priceUtil from '~/utils/priceUtil'

export default {
  name: 'ep-upload-about',
  props: {
    initPrivacy: String,
    initTitle: String,
    initDescription: String,
    initPrice: Object
  },
  data () {
    return {
      expanded: true,
      privacy: '',
      title: '',
      description: '',
      price: { amount: 0 },
      validPrices: [],
      label: {
        ABOUT: 'ABOUT',
        GAME_TITLE: 'Game Title',
        GAME_TITLE_PLACEHOLDER: 'e.g. Awesome Game',
        DESCRIPTION: 'Description',
        DESCRIPTION_PLACEHOLDER: 'e.g. This game is awesome!',
        PRICE: 'Price Tier',
        FREE_TO_PLAY: 'FREE TO PLAY',
        PRIVACY: 'Privacy',
        PUBLIC: 'Public',
        UNLISTED: 'Unlisted',
        PRIVATE: 'Private'
      }
    }
  },
  validations: {
    title: {
      required,
      maxLength: maxLength(100)
    },
    description: {
      required
    },
    price: {
      isValidPrice
    }
  },
  watch: {
    initPrivacy () {
      this.privacy = this.initPrivacy
    },
    initTitle () {
      this.title = this.initTitle
    },
    initDescription () {
      this.description = this.initDescription
    },
    initPrice () {
      this.price.amount = this.initPrice.amount
    },
    privacy () {
      this.$emit('privacy', this.privacy)
    },
    title () {
      this.$emit('title', this.title)
    },
    description () {
      this.$emit('description', this.description)
    },
    'price.amount' () {
      this.$emit('price', this.price)
    }
  },
  computed: {
    isEditForm () {
      return this.initPrivacy
    }
  },
  mounted () {
    this.validPrices = priceUtil.validPrices
  },
  methods: {
    toggleExpanded () {
      this.expanded = !this.expanded
    },
    totalPrice (amount, currency) {
      return priceUtil.totalPrice(amount, currency)
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';

.upload-about {
  display: block;
  position: relative;
  margin: 0;
  padding: 16px;
  border-right: none;
  border-left: none;
  border-bottom: 1px solid #dcdcdc;
}

.content {
  margin-top: 20px;
}

.error {
  margin-bottom: 20px;
  color: #cc0000;

  &.signUpError {
    margin-top: 12px;
    margin-bottom: 0;
  }
}
</style>
